% !TEX root = main.tex
\newpage
\appendices

\section{Comparison against Random Graphs with Representative Neighborhoods}
\label{app:random_repr} 

Recall that D-Cliques (i) ensure that the label distribution in the local
neighborhood of each node is
representative of the global distributions, (ii) enable the use of
 Clique Averaging to debias gradients, and (iii) provide a high level of
 clustering (i.e., neighbors 
 of a node are neighbors themselves), which tends to lower variance.
In order to distinguish the effect of the first two from the last, in this
section we compare D-Cliques to a
random graph that has \emph{representative} neighborhoods.

To make a fair comparison and simplify the construction of such a random
graph, we consider a
different data partitioning scheme than in the main text. Specifically, the
local dataset of each node consists of a single class, and all classes are
represented on the same number of nodes.\footnote{In the extended version of this paper~\cite{dcliques-arxiv}, we reproduce all
experiments of the main text with this different data partitioning scheme, and
generally find consistent results.}

In the above setup, the
construction of
both D-Cliques and random graphs with representative neighborhood is
straightforward and ensures that in both cases the skew of the cliques 
or neighborhood is exactly 0. This removes the
challenge of designing topology
optimization algorithms for both D-Cliques and random graphs that would
guarantee reaching the same level of skew in both cases to make results comparable.

\begin{figure}[ht]
     \centering     
         \begin{subfigure}[b]{0.23\textwidth}
         \centering
         \includegraphics[width=\textwidth]{figures/convergence-mnist-random-vs-d-cliques-1-class-per-node}
                  \caption{MNIST}
         \end{subfigure}
                 \hfill                      
        \begin{subfigure}[b]{0.23\textwidth}
        \centering
         \includegraphics[width=\textwidth]{figures/convergence-cifar10-random-vs-d-cliques-1-class-per-node}
         \caption{CIFAR10}
     \end{subfigure} 
 \caption{\label{fig:convergence-random-vs-d-cliques-1-class-per-node} Comparison to variations of Random Graph with 10 edges per node on 100 nodes (variation of \autoref{fig:convergence-random-vs-d-cliques-2-shards} with 1 class/node instead as well as constraining the random graph so the neighborhood of each node has zero skew).} 
\end{figure}

The results are shown in 
\autoref{fig:convergence-random-vs-d-cliques-1-class-per-node}. Note that in
general, the effect of data heterogeneity on the convergence is actually
stronger with the data partitioning considered here (see for instance 
\autoref{fig:convergence-random-vs-d-cliques-2-shards} in comparison), which
is expected since it exhibits extreme
label skew.
On MNIST, we observe that a
random graph with representative neighborhoods is marginally better than
D-Cliques
without Clique Averaging. We hypothesize that the slightly better mixing
provided by the random graph, compared to cliques, provides a small advantage.
On CIFAR10, when using momentum, D-Cliques converge faster even without Clique
Averaging. In this case, it seems the clustering has a more beneficial effect
than the marginal gain in mixing of the random graph. For both MNIST and
CIFAR10, the clustering provided by D-Cliques, in combination with Clique
Averaging, provides faster convergence and lower variance than diverse
neighborhoods.

In practice, the difficulty of obtaining a random graph in which each node has a neighborhood with similar skew as D-Cliques, while not using more edges, makes the construction with a decentralized algorithm harder. Indeed, there are more constraints in selecting potential candidates for swapping.










